#!/bin/bash

##############################################################################################################################################
# #Nom:configura_resolucio.sh                                                                                                                                                                                                                                                            # 
# Llicència: GPL v3.0                                                                                                                        #
# Autor: Joan de Gracia. Servei TAC. Departament d'Educació                                                                                  #
#
# Versió: 1.2                                                                                                                                #
# Data: 07-12-2016                                                                                                                          
#
# Versió: 1.1                                                                                                                                #
# Data: 01-05-2010                                                                                                                           #
##############################################################################################################################################

CONFIG_FILE=/etc/linkat-xrandr.conf
XRANDR="$(which xrandr)"
ZENITY="$(which zenity)"
RESPOSTA=""
while [ "$RESPOSTA" == "" ]; do
    RESPOSTA=$($ZENITY  \
    --list \
    --title="Utilitat: canvi de resolució de pantalles" \
    --column="Mode"  \
        Clonacio \
        Extensio \
        Aturar)
    if [ "$?" != "0" ]; then
    {
        $ZENITY --info --text="Acabes de tancar l'aplicatiu"
        exit 0
    }
    fi 
done
case $RESPOSTA in
#
# CLONACIÓ
#
Clonacio)
	#
	# Mode Clonació
	#
	RESOLUCIO_RESPOSTA=""      # Correspon a la tria de la resolucio de pantalla
	FLAG_CONFIGURACIO_NOVA=""  # Correspon a la configuració de nou de la/les pantalla/es
	FLAG_DESAR_CONFIGURACIO=""
	FLAG_MONITOR=""
	MONITOR_INTERN=""
	MONITOR_EXTERN=""
	while [ "$MONITOR_INTERN" == "" ]; do
    	MONITOR_INTERN=$($ZENITY \
		--width=350 \
        --height=200 \
		--list \
		--print-column=ALL \
		--title="Tria la pantalla INTERNA (p.e. LVDS)" \
		--column="Posició" \
		$($XRANDR |grep "\<connected\>" | awk -F ' ' ' {print $1} '))
		if [ "$?" != "0" ]; then
		{
            $ZENITY --info --text="Acabes de tancar l'aplicatiu"
			exit 0
		} 
		fi
    done
    while [ "$MONITOR_EXTERN" == "" ]; do
        MONITOR_EXTERN=$($ZENITY \
        --width=350 \
        --height=200 \
		--list \
    	--print-column=ALL \
        --title="Tria la pantalla EXTERNA (p.e. VGA)" \
        --column="Posició" \
        $($XRANDR |grep "\<connected\>" | grep --invert-match $MONITOR_INTERN | awk -F ' ' ' {print $1} '))
    if [ "$?" != "0" ]; then
    {
        $ZENITY --info --text="Acabes de tancar l'aplicatiu"
        exit 0
    }
    fi 
    if [ "$MONITOR_EXTERN" == "" ]; then
        $ZENITY --info --text="El monitor o canó extern no està connectat"
    fi
    done
   #
   # Si la pantalla externa suporta 1024x600 es defineix aquest mode
   #
   # if [ -n "$MONITOR_EXTERN" ]; then
   #     if [ -n "$($XRANDR --addmode $MONITOR_EXTERN 1024x600 2>&1)" ]; then
   #         $ZENITY --info --text="El teu monitor no suporta la resolució 1024x600"
   #     fi
   # fi
#   MONITORS=$(xrandr |grep "\<connected\>")
    while [ "$FLAG_CONFIGURACIO_NOVA" == "" ]; do
        RESOLUCIONS=""
		for i in $($XRANDR | grep --invert-match $MONITOR_INTERN |grep -v disconnected | awk -F ' ' ' {print $1} ' ); do
		{
            if [ -z "$(echo $i |grep x | grep -v HSync)" ]; then
            {
                if [ -n "$(echo $i |grep $MONITOR_EXTERN)" ]; then
                {
                    MONITOR=$i
                    FLAG_MONITOR=1
                }
                else
                {
                    FLAG_MONITOR=0
                }
                fi
            }
            else
                if [ $FLAG_MONITOR == 1 ]; then
                {
                    NOVA=$(echo -n $MONITOR $i " ")
                    RESOLUCIONS=${RESOLUCIONS}${NOVA}
                }
                fi
            fi
        }
		done
        while [ "$RESOLUCIO_RESPOSTA" == "" ]; do
   	    	RESOLUCIO_RESPOSTA=$($ZENITY  --width=350 \
            --height=200 \
            --list \
            --print-column=ALL \
            --title="Tria la resolucio de la pantalla externa" \
            --column="Pantalla" --column="Resolució" $RESOLUCIONS)      		         
            if [ "$?" != "0" ]; then
            {
                $ZENITY --info --text="Acabes de tancar l'aplicatiu"
                exit 0
            } 
            fi      		         
        done 		         
		PANTALLA=$(echo $RESOLUCIO_RESPOSTA |cut -d "|" -f1)
		RESOLUCIO=$(echo $RESOLUCIO_RESPOSTA |cut -d "|" -f2)
		RESOLUCIO_RESPOSTA=""
        FLAG_CONFIGURACIO_NOVA=$($ZENITY --question \
        --text="Vols continuar amb la resolució escollida?\n\r" \
        --title="Pregunta" \
        --ok-label="Sí" \
        --cancel-label="No")
        if [ "$?" = "0" ]; then
        {
            if [ -n "$($XRANDR --auto --output $PANTALLA --mode $RESOLUCIO --same-as $MONITOR_INTERN)" ]; then
                $ZENITY --info --text="La pantalla $PANTALLA no suporta la resolució: $RESOLUCIO"
            else
		$XRANDR --auto --output $MONITOR_INTERN --mode $RESOLUCIO
                $ZENITY --info --text="La pantalla $PANTALLA té assignada la resolució: $RESOLUCIO"		 		         
            fi
        } 
        fi

#
# PREGUNTAR PER SI ES VOL DESAR ELS CANVIS
#
        FLAG_DESAR_CONFIGURACIO=$($ZENITY --question \
        --text="Vols desar aquests canvis perquè s'apliquin a tots els usuaris?\n\r" \
        --title="Pregunta" \
        --ok-label="Sí" \
        --cancel-label="No")
        if [ "$?" = "0" ]; then
        {
            echo "MODE=CLONACIO" > $CONFIG_FILE
        	echo "MONITOR_EXTERN=$PANTALLA" >> $CONFIG_FILE
        	echo "MONITOR_INTERN=$MONITOR_INTERN" >> $CONFIG_FILE
        	echo "RESOLUCIO=$RESOLUCIO" >> $CONFIG_FILE
        } 
        fi
        exit 0
    done
	;;	
#
# EXTENSIO
#
	Extensio)
	# Mode Extensió
   	RESOLUCIO_RESPOSTA=""      # Correspon a la tria de la resolucio de pantalla
   	POSICIO_RESPOSTA=""
   	FLAG_CONFIGURACIO_NOVA=""  # Correspon a la configuració de nou de la/les pantalla/es
	FLAG_DESAR_CONFIGURACIO=""
	FLAG_MONITOR=""
    MONITOR_INTERN=""
    MONITOR_EXTERN=""
   	while [ "$MONITOR_INTERN" == "" ]; do
    MONITOR_INTERN=$($ZENITY \
        --width=350 \
        --height=200 \
		--list \
		--print-column=ALL \
        --title="Tria la pantalla INTERNA (p.e. LVDS)" \
        --column="Posició" \
        $($XRANDR |grep "\<connected\>" | awk -F ' ' ' {print $1} '))
        if [ "$?" != "0" ]; then
        {
            $ZENITY --info --text="Acabes de tancar l'aplicatiu"
            exit 0
        } 
        fi
    done
    while [ "$MONITOR_EXTERN" == "" ]; do
    MONITOR_EXTERN=$($ZENITY \
        --width=350 \
        --height=200 \
        --list \
        --print-column=ALL \
        --title="Tria la pantalla EXTERNA (p.e. VGA)" \
        --column="Posició" \
        $($XRANDR |grep "\<connected\>" | grep --invert-match $MONITOR_INTERN | awk -F ' ' ' {print $1} '))
         if [ "$?" != "0" ]; then
         {
            $ZENITY --info --text="Acabes de tancar l'aplicatiu"
            exit 0
         }
         fi 
         if [ "$MONITOR_EXTERN" == "" ]; then
            $ZENITY --info --text="El monitor o canó extern no està connectat"
         fi                
    done
    while [ "$FLAG_CONFIGURACIO_NOVA" == "" ]; do
        RESOLUCIONS=""
		for i in $($XRANDR | grep --invert-match $MONITOR_INTERN |grep -v disconnected | awk -F ' ' ' {print $1} ' ); do
		{
            if [ -z "$(echo $i |grep x | grep -v HSync)" ]; then
            {
                if [ -n "$(echo $i |grep $MONITOR_EXTERN)" ]; then
                {
                    MONITOR=$i
                    FLAG_MONITOR=1
                }
                else
                {
                    FLAG_MONITOR=0
                }
                fi
            }
            else
                if [ $FLAG_MONITOR == 1 ]; then
                {
                    NOVA=$(echo -n $MONITOR $i " ")
                    RESOLUCIONS=${RESOLUCIONS}${NOVA}
                }
                fi
            fi
        }
		done
    while [ "$RESOLUCIO_RESPOSTA" == "" ]; do
        RESOLUCIO_RESPOSTA=$($ZENITY  --width=350 \
            --height=220 \
            --list \
            --print-column=ALL \
            --title="Tria la resolucio de la pantalla externa" \
            --column="Pantalla" --column="Resolució" $RESOLUCIONS)      		         
            if [ "$?" != "0" ]; then
            {
         		$ZENITY --info --text="Acabes de tancar l'aplicatiu"
               exit 0
            } 
            fi      		         
            PANTALLA=$(echo $RESOLUCIO_RESPOSTA |cut -d "|" -f1)            
            if [ -n "$(echo $PANTALLA | grep $MONITOR_INTERN)" ]; then
         		$ZENITY --info --text="No pots triar la pantalla de l'ordinador en el mode: Extès"
         		RESOLUCIO_RESPOSTA=""
      		else        	
               RESOLUCIO=$(echo $RESOLUCIO_RESPOSTA |cut -d "|" -f2)  			      		
      		fi          
    done
    while [ "$POSICIO_RESPOSTA" == "" ]; do
        POSICIO_RESPOSTA=$($ZENITY  --width=350 \
        --height=220 \
        --list \
        --print-column=ALL \
        --title="Tria la posició de la pantalla externa" \
        --column="Posició" \
        ESQUERRA \
        DRETA \
        AMUNT \
        AVALL)     		         
        if [ "$?" != "0" ]; then
        {
            $ZENITY --info --text="Acabes de tancar l'aplicatiu"
            exit 0
        } 
        fi
    done     		
    FLAG_CONFIGURACIO_NOVA=$($ZENITY --question \
        --text="Vols continuar amb la resolució escollida?\n\r" \
        --title="Pregunta" \
        --ok-label="Sí" \
        --cancel-label="No")
    if [ "$?" = "0" ]; then
    {
        case $POSICIO_RESPOSTA in
            ESQUERRA)
                SITE="left-of"
                ;;
            DRETA)
                SITE="right-of"
                ;;
            AMUNT)
                SITE="above"
                ;;
            AVALL)
                SITE="below"
                ;;
        esac    
        if [ -n "$($XRANDR --auto --output $PANTALLA --mode $RESOLUCIO --$SITE $MONITOR_INTERN)" ]; then
            $ZENITY --info --text="La pantalla $PANTALLA no suporta la resolució: $RESOLUCIO"
        else
            $ZENITY --info --text="La pantalla $PANTALLA té assignada la resolució: $RESOLUCIO\n\r\
    Recorda que l'escriptori extès el trobaràs a la posició: $POSICIO_RESPOSTA en relació a la pantalla de l'ordinador"
        fi
    } 
    fi
#
# PREGUNTAR PER SI ES VOL DESAR ELS CANVIS
#

        FLAG_DESAR_CONFIGURACIO=$($ZENITY --question \
        --text="Vols desar aquests canvis perquè s'apliquin a tots els usuaris?\n\r" \
        --title="Pregunta" \
        --ok-label="Sí" \
        --cancel-label="No")
        if [ "$?" = "0" ]; then
        {
            echo "MODE=EXTENSIO" > $CONFIG_FILE
            echo "MONITOR_EXTERN=$PANTALLA" >> $CONFIG_FILE
            echo "MONITOR_INTERN=$MONITOR_INTERN" >> $CONFIG_FILE
            echo "RESOLUCIO=$RESOLUCIO" >> $CONFIG_FILE
            echo "POSICIO=$SITE" >> $CONFIG_FILE
        } 
        fi
        exit 0
  done
	;;	
#
# ATURAR
#
    Aturar)
        if [ -e $CONFIG_FILE ]; then
            rm $CONFIG_FILE
        fi
    exit 0
	;;
esac
